      SUBROUTINE  findrest_4(npl,plx,ply)
c
c...This Implements The Star Finding Code for radius=3
c
c
c	The value of IAMIN is the Minimum Acceptable Area for a Star.
c
c     		1 means Only Central Pixel is ON
c    		21 means All Pixels are ON
c
c	The value of IPMAX is the Maximum Acceptable Perimiter for a Star.
c
c		     0 means  NO Pixels ON
c		    16 means ALL Pixels ON
c
      INCLUDE
     *            '../all4.inc'
      PARAMETER
     *            iamin=1, ipmax=0
      INTEGER
     *            ix, iy, ibase, iarea, npl, plx(*), ply(*),
     *            jbase, jx, jy, j, n, xn(21), yn(21)
      INTEGER*2
     *            wvect(lrows*lcols), jtest, jvect(mcols*mrows)
      REAL
     *            x, y, z
      EQUIVALENCE
     *            (dn1p(lcfrst,lrfrst),wvect(1)),
     *            (tiny(1,1),jvect(1))
c
c...Loop In (IX,IY) Needed For Reference To TINY
c
  100 DO iy=1,mrows
        ibase = (iy+nfringe-1)*lcols + nfringe
        DO ix=1,mcols
          ibase = ibase+1
c
c...The Central Pixel Must be ON
c
          IF (wvect(ibase).eq.0) GO TO 199
          npl = 0
c
c...The Radius=3 Ring Perimiter is computed and tested
c
          IF (wvect(ibase+3*lcols-1) + wvect(ibase+3*lcols  )
     *      + wvect(ibase+3*lcols+1) + wvect(ibase+2*lcols-2)
     *      + wvect(ibase+2*lcols+2) + wvect(ibase+  lcols-3)
     *      + wvect(ibase+  lcols+3) + wvect(ibase        -3)
     *      + wvect(ibase        +3) + wvect(ibase-  lcols-3)
     *      + wvect(ibase-  lcols+3) + wvect(ibase-2*lcols-2)
     *      + wvect(ibase-2*lcols+2) + wvect(ibase-3*lcols-1)
     *      + wvect(ibase-3*lcols  ) + wvect(ibase-3*lcols+1)
     *     .gt.ipmax) GO TO 199
c
c...The Radius=3 Ring Area is computed and tested
c
          iarea=wvect(ibase+2*lcols-1) + wvect(ibase+2*lcols  )
     *        + wvect(ibase+2*lcols+1) + wvect(ibase+  lcols-2)
     *        + wvect(ibase+  lcols-1) + wvect(ibase+  lcols  )
     *        + wvect(ibase+  lcols+1) + wvect(ibase+  lcols+2)
     *        + wvect(ibase        -2) + wvect(ibase        -1)
     *        + wvect(ibase        +1) + wvect(ibase        +2)
     *        + wvect(ibase-  lcols-2) + wvect(ibase-  lcols-1)
     *        + wvect(ibase-  lcols  ) + wvect(ibase-  lcols+1)
     *        + wvect(ibase-  lcols+2) + wvect(ibase-2*lcols-1)
     *        + wvect(ibase-2*lcols  ) + wvect(ibase-2*lcols+1)
     *        + 1
          IF (iarea.lt.iamin) GO TO 199
c
c...Something Is Here
c
          IF (wvect(ibase+2*lcols-1).ne.0) THEN
            CALL plappend_4(ix-1,iy+2,npl,plx,ply)
          ENDIF
          IF (wvect(ibase+2*lcols  ).ne.0) THEN
            CALL plappend_4(ix  ,iy+2,npl,plx,ply)
          ENDIF
          IF (wvect(ibase+2*lcols+1).ne.0) THEN
            CALL plappend_4(ix+1,iy+2,npl,plx,ply)
          ENDIF
c
          IF (wvect(ibase+  lcols-2).ne.0) THEN
            CALL plappend_4(ix-2,iy+1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase+  lcols-1).ne.0) THEN
            CALL plappend_4(ix-1,iy+1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase+  lcols  ).ne.0) THEN
            CALL plappend_4(ix  ,iy+1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase+  lcols+1).ne.0) THEN
            CALL plappend_4(ix+1,iy+1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase+  lcols+2).ne.0) THEN
            CALL plappend_4(ix+2,iy+1,npl,plx,ply)
          ENDIF
c
          IF (wvect(ibase        -2).ne.0) THEN
            CALL plappend_4(ix-2,iy  ,npl,plx,ply)
          ENDIF
          IF (wvect(ibase        -1).ne.0) THEN
            CALL plappend_4(ix-1,iy  ,npl,plx,ply)
          ENDIF
          CALL plappend_4(ix  ,iy  ,npl,plx,ply)
          IF (wvect(ibase        +1).ne.0) THEN
            CALL plappend_4(ix+1,iy  ,npl,plx,ply)
          ENDIF
          IF (wvect(ibase        +2).ne.0) THEN
            CALL plappend_4(ix+2,iy  ,npl,plx,ply)
          ENDIF
c
          IF (wvect(ibase-  lcols-2).ne.0) THEN
            CALL plappend_4(ix-2,iy-1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase-  lcols-1).ne.0) THEN
            CALL plappend_4(ix-1,iy-1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase-  lcols  ).ne.0) THEN
            CALL plappend_4(ix  ,iy-1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase-  lcols+1).ne.0) THEN
            CALL plappend_4(ix+1,iy-1,npl,plx,ply)
          ENDIF
          IF (wvect(ibase-  lcols+2).ne.0) THEN
            CALL plappend_4(ix+2,iy-1,npl,plx,ply)
          ENDIF
c
          IF (wvect(ibase-2*lcols-1).ne.0) THEN
            CALL plappend_4(ix-1,iy-2,npl,plx,ply)
          ENDIF
          IF (wvect(ibase-2*lcols  ).ne.0) THEN
            CALL plappend_4(ix  ,iy-2,npl,plx,ply)
          ENDIF
          IF (wvect(ibase-2*lcols+1).ne.0) THEN
            CALL plappend_4(ix+1,iy-2,npl,plx,ply)
          ENDIF
          CALL plproc_4(npl,plx,ply)
c
c...Clean Up the Work Picture
c
          wvect(ibase+3*lcols-1)=0
          wvect(ibase+3*lcols  )=0
          wvect(ibase+3*lcols+1)=0
          wvect(ibase+2*lcols-2)=0
          wvect(ibase+2*lcols-1)=0
          wvect(ibase+2*lcols  )=0
          wvect(ibase+2*lcols+1)=0
          wvect(ibase+2*lcols+2)=0
          wvect(ibase+  lcols-3)=0
          wvect(ibase+  lcols-2)=0
          wvect(ibase+  lcols-1)=0
          wvect(ibase+  lcols  )=0
          wvect(ibase+  lcols+1)=0
          wvect(ibase+  lcols+2)=0
          wvect(ibase+  lcols+3)=0
          wvect(ibase        -3)=0
          wvect(ibase        -2)=0
          wvect(ibase        -1)=0
          wvect(ibase          )=0
          wvect(ibase        +1)=0
          wvect(ibase        +2)=0
          wvect(ibase        +3)=0
          wvect(ibase-  lcols-3)=0
          wvect(ibase-  lcols-2)=0
          wvect(ibase-  lcols-1)=0
          wvect(ibase-  lcols  )=0
          wvect(ibase-  lcols+1)=0
          wvect(ibase-  lcols+2)=0
          wvect(ibase-  lcols+3)=0
          wvect(ibase-2*lcols-2)=0
          wvect(ibase-2*lcols-1)=0
          wvect(ibase-2*lcols  )=0
          wvect(ibase-2*lcols+1)=0
          wvect(ibase-2*lcols+2)=0
          wvect(ibase-3*lcols-1)=0
          wvect(ibase-3*lcols  )=0
          wvect(ibase-3*lcols+1)=0
  199   CONTINUE
        ENDDO
      ENDDO
      RETURN
      END
