      SUBROUTINE  cc_fastxyz(err)
c
c...Fast XYZ For SAMPLEing
c
      INCLUDE
     *            'c.inc'
      PARAMETER
     *            NSAMPLE = 4,
     *            chan_0 = 0,
     *            chan_1 = 1
      DOUBLE PRECISION
     *            x, y
      REAL
     *            volt, s, ss, sn
      INTEGER
     *            err, DEV_RTSANO, DEV_PJVOLT, i, n, chan, gain
c
 9001 FORMAT (2f20.0)
c
c...Get Information From Anomatic-III.  Very Similar To CC_ANOGETXYZA
c
  100 CALL cc_fromchar('G58 XF9.5 YF9.5',nxmt,xmt)
      nrcv = NIOMAX
      err = DEV_RTSANO(nxmt,xmt,nrcv,rcv,-1,ANO_TIMEOUT)
      IF (err.ne.0) THEN
        panic = IOR(panic,PANIC_ANO_QIO)
        GO TO 120
      ENDIF
      CALL cc_addcomma(nrcv,rcv,nlb,lb,n)
      IF (n.ne.2) THEN
        panic = IOR(panic,PANIC_ANO_RE)
        err = -1
        GO TO 120
      ENDIF
      READ (lb(1:nlb),9001,err=110) x,y
      curpos(1) = x
      curpos(2) = y
      err = 0
      GO TO 120
  110 panic = IOR(panic,PANIC_ANO_RE)
      err = -2
      GO TO 120
c
c...Always Sense The Z Sensors.  Very Similar To CC_ZSENSE
c
c	MODIFIED.  TAKE Does Not Need Z
c
c...Camera 0
c
  120 IF (takeflag.ne.0) RETURN
      sn = NSAMPLE
      s = 0.0
      ss = 0.0
      chan = CHAN_0
      gain = 1
      err = DEV_PJVOLT(chan,gain,volt)
      DO i=1,NSAMPLE
        err = DEV_PJVOLT(chan,gain,volt)
        s = s + volt
        ss = ss + volt*volt
      ENDDO
      s = s/sn
      ss = SQRT(ABS(ss/sn - s*s))
      curpos(5) = s
      postol(5) = ss
c
c...Camera 1
c
      s = 0.0
      ss = 0.0
      chan = CHAN_1
      gain = 1
      err = DEV_PJVOLT(chan,gain,volt)
      DO i=1,NSAMPLE
        err = DEV_PJVOLT(chan,gain,volt)
        s = s + volt
        ss = ss + volt*volt
      ENDDO
      s = s/sn
      ss = SQRT(ABS(ss/sn - s*s))
      curpos(6) = s
      postol(6) = ss
      RETURN
      END
