      SUBROUTINE  cc_goto(err)
c
c...Return ERR==0 Only If PMM Is Ready To Move
c
      INCLUDE
     *            'c.inc'
      PARAMETER
     *            npanic = 30
      INTEGER
     *            err, ready, i, j, nbb, DEV_ANOWRITE, n
      CHARACTER*11
     *            bb
      CHARACTER*1
     *            axis(4)
      DOUBLE PRECISION
     *            target
      DATA
     *            axis/'X', 'Y', 'Z', 'A'/
c
 9001 FORMAT (' MOVE Not Ready ', i10)
 9002 FORMAT (' MOVE Current Position Unknown ', i10)
 9003 FORMAT (' MOVE Already Moving ', i10)
 9004 FORMAT (a, f10.5)
 9006 FORMAT (' MOVE Cannot Talk', i10)
 9007 FORMAT (' MOVE Cannot Write ', i1, 3x, 1pe14.7)
 9008 FORMAT (' MOVE In Panic ', z10)
 9009 FORMAT ('ANOSTAT ', i2, '::', 4a1, '::', 4f10.4)
 9010 FORMAT (' MOVE Cannot Hang', i10)
c
c...ANOSTAT Monitors Motion And Limits
c
  100 IF (ano_open.eq.0) RETURN
      IF (panic.ne.0) THEN
        WRITE (*,9008) panic
        err = -6
        RETURN
      ENDIF
      IF (ano_seq.ne.0) THEN
        WRITE (*,9003) ano_seq
        err = -3
        RETURN
      ENDIF
c
c...Debugging A Failure Near Here
c
      n = 0
  110 CALL cc_anostat(ready)
      IF (ready.ne.1) THEN
        n = n+1
        IF (n.le.NPANIC) THEN
          CALL cc_sleep(1.0)
          GO TO 110
        ENDIF
        WRITE (*,9001) ready
        err = -1
        RETURN
      ENDIF
c
      CALL cc_anogetxyza(err)
      IF (err.ne.0) THEN
        WRITE (*,9002) err
        err = -2
        RETURN
      ENDIF
c
c...Figure Out Who Is To Move
c
      nlb = 0
      DO i=1,4
        target = reqpos(i)+offset(i)
        IF ((golaser.ne.0).and.(offset(i).eq.0.0D00)) THEN
          IF ((i.eq.1).or.(i.eq.2)) THEN
            target = target + laseroff(i,golaser)
          ENDIF
        ENDIF
        movdist(i) = ABS(target-curpos(i))
        offset(i) = 0.0D00
        IF (movdist(i).ge.postol(i)) THEN
          WRITE (bb,9004,err=200) axis(i),target
          CALL cc_deblank(bb,nbb,bb)
          DO j=1,nbb
            nlb = nlb+1
            lb(nlb:nlb) = bb(j:j)
          ENDDO
          domove(i) = 1
        ELSE
          domove(i) = 0
        ENDIF
      ENDDO
      IF (nlb.le.0) THEN
        err = 0
        RETURN
      ENDIF
c
c...Start The Move
c
      CALL cc_fromchar(lb(1:nlb),nxmt,xmt)
      err = DEV_ANOWRITE(nxmt,xmt)
      IF (err.ne.0) THEN
        WRITE (*,9006) err
        err = -4
        RETURN
      ENDIF
      CALL cc_sleep(0.3)
      CALL cc_fromchar('G5G58"/"',nxmt,xmt)
      err = DEV_ANOWRITE(nxmt,xmt)
      IF (err.ne.0) THEN
        WRITE (*,9010) err
        err = -5
        RETURN
      ENDIF
      CALL cc_gettime(ano_time)
      ano_seq = 2
      err = 0
      RETURN
c
c...Error Exit
c
  200 WRITE (*,9007) i,target
      err = -5
      RETURN
      END
