      SUBROUTINE  cc_plate(err)
c
c...Define Many Things For A Plate Pair
c
      INCLUDE
     *            'c.inc'
      INTEGER
     *            err, mm, dd, yy, i, j
      CHARACTER*15
     *            tb
      CHARACTER*5
     *            tp13, tp24
      DOUBLE PRECISION
     *            zx, zy
c
 9001 FORMAT (i2.2, ':')
 9002 FORMAT (i5.5)
 9003 FORMAT ('0=ID', f7.3, ',', f7.3, ',', 2i1, a)
 9004 FORMAT ('1=ID', f7.3, ',', f7.3, ',', 2i1, a)
c
c...Sanity Check
c
  100 IF (INDEX(lb(1:nlb),'12').gt.0) THEN
        usearea = 1
      ELSEIF (INDEX(lb(1:nlb),'34').gt.0) THEN
        usearea = 2
      ELSE
        err = -1
        RETURN
      ENDIF
      IF ((holder.lt.1).or.(holder.gt.2)) THEN
        err = -2
        RETURN
      ENDIF
c
c...Define PMM Areas And Nominals
c
      IF (usearea.eq.1) THEN
        lb(1:7) = 'MINMAX1'
        nlb = 7
        CALL cc_minmax(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDZ1'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDA1'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
      ELSE
        lb(1:7) = 'MINMAX2'
        nlb = 7
        CALL cc_minmax(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDZ2'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDA2'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
      ENDIF
c
c...Get Current Time And Tape Information
c
      CALL IDATE(mm,dd,yy)
      WRITE (tb(1:3),9001) yy
      CALL cc_gettime(tb(4:15))
      WRITE (tp13,9002) tapeid(1)
      WRITE (tp24,9002) tapeid(2)
c
c...Update SG Plate Name
c
      IF (usearea.eq.1) THEN
        zx = minval(1)+separation(1)
        zy = minval(2)+separation(2)
        j = 1
        WRITE (lb,9003) zx,zy,holder,j,plateid(j)(1:nplateid(j))
        nlb = 22+nplateid(j)
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(j)) + LEN(plemul(j)) + LEN(pltim(j))
     *      + LEN(plra(j)) + LEN(pldec(j)) + LEN(plexp(j))
     *      + LEN(tb) + LEN(tp13)
        lb(1:nlb) = '0=INFO'//plsurvey(j)//plemul(j)//pltim(j)
     *                      //plra(j)//pldec(j)//plexp(j)//tb//tp13
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
      ELSE
        zx = minval(1)+separation(1)
        zy = minval(2)+separation(2)
        j = 3
        WRITE (lb,9003) zx,zy,holder,j,plateid(j)(1:nplateid(j))
        nlb = 22+nplateid(1)
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(j)) + LEN(plemul(j)) + LEN(pltim(j))
     *      + LEN(plra(j)) + LEN(pldec(j)) + LEN(plexp(j))
     *      + LEN(tb) + LEN(tp13)
        lb(1:nlb) = '0=INFO'//plsurvey(j)//plemul(j)//pltim(j)
     *                      //plra(j)//pldec(j)//plexp(j)//tb//tp13
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
      ENDIF
      IF (usearea.eq.1) THEN
        zx = minval(1)
        zy = minval(2)
        j = 2
        WRITE (lb,9004) zx,zy,holder,j,plateid(j)(1:nplateid(j))
        nlb = 22+nplateid(1)
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(j)) + LEN(plemul(j)) + LEN(pltim(j))
     *      + LEN(plra(j)) + LEN(pldec(j)) + LEN(plexp(j))
     *      + LEN(tb) + LEN(tp24)
        lb(1:nlb) = '1=INFO'//plsurvey(j)//plemul(j)//pltim(j)
     *                      //plra(j)//pldec(j)//plexp(j)//tb//tp24
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
      ELSE
        zx = minval(1)
        zy = minval(2)
        j = 4
        WRITE (lb,9004) zx,zy,holder,j,plateid(j)(1:nplateid(j))
        nlb = 22+nplateid(1)
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(j)) + LEN(plemul(j)) + LEN(pltim(j))
     *      + LEN(plra(j)) + LEN(pldec(j)) + LEN(plexp(j))
     *      + LEN(tb) + LEN(tp24)
        lb(1:nlb) = '1=INFO'//plsurvey(j)//plemul(j)//pltim(j)
     *                      //plra(j)//pldec(j)//plexp(j)//tb//tp24
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
      ENDIF
      RETURN
      END
