      SUBROUTINE  cc_sequen(err)
c
c...Load And Execute A Sequence
c
      INCLUDE
     *            'c.inc'
      INTEGER
     *            err, i, j, DEV_QTER, ret(NDEEPMAX)
c
 9001 FORMAT ('LOOP', i3)
 9002 FORMAT (4x, i3)
c
c...Open User Requested Sequence File
c
  100 CALL cc_seqload(err)
      IF (err.ne.0) RETURN
      seqstep = 0
      ret(deep) = -1
c
c...Read Next Instruction
c
  110 CALL cc_nextline(err)
c
c...Error Means No More Instructions
c
      IF (err.ne.0) THEN
        CALL cc_fclose(err)
        IF (err.ne.0) GO TO 200
        IF (deep.gt.0) THEN
          GO TO 110
        ELSE
          GO TO 120
        ENDIF
      ENDIF
c
c...SEQ Instruction Tags Current Location And Opens Next File
c
      IF (lb(1:3).eq.'SEQ') THEN
        seqstep = seqstep+1
        seqline(seqstep) = 'SINIT'
        nseqline(seqstep) = 5
        CALL cc_seqload(err)
        IF (err.ne.0) GO TO 200
        ret(deep) = seqstep
c
c...MACRO Instruction Is Like SEQ Except That It Does Not Do SINIT
c
      ELSEIF (lb(1:3).eq.'MAC') THEN
        CALL cc_macload(err)
        IF (err.ne.0) GO TO 200
        ret(deep) = seqstep
c
c...LOOP Instruction Generates Instruction To Iterate
c
      ELSEIF (lb(1:4).eq.'LOOP') THEN
        seqstep = seqstep+1
        WRITE (seqline(seqstep),9001) ret(deep)
        nseqline(seqstep) = 7
c
c...BEGINLOOP Move Loop Start Pointer To Current Location
c
      ELSEIF (lb(1:9).eq.'BEGINLOOP') THEN
        ret(deep) = seqstep
c
c...Normal Instructions Are Stored
c
      ELSE
        seqstep = seqstep + 1
        seqline(seqstep) = lb
        nseqline(seqstep) = nlb
      ENDIF
      GO TO 110
c
c...Execute The Sequence
c
  120 i = 0
      CALL cc_preseq
  130 i = i+1
      IF (i.le.seqstep) THEN
        lb = seqline(i)
        nlb = nseqline(i)
        j = DEV_QTER()
        IF ((j.gt.0).and.(j.le.26).and.(j.ne.10).and.(j.ne.13)) THEN
          err = -1
          GO TO 140
        ENDIF
c
c...LOOP Instruction Updates I
c
        IF (lb(1:4).eq.'LOOP') THEN
          READ (lb(1:nlb),9002) i
          GO TO 130
c
c...ERR=999 On Decision Statements Skips Next Instruction
c
        ELSEIF ((lb(1:4).eq.'INCR')
     *      .or.(lb(1:6).eq.'RASTER')
     *      .or.(lb(1:5).eq.'NINCR')
     *      .or.(lb(1:6).eq.'PROCSG')) THEN
          CALL cc_parse(err)
          IF (err.eq.0) THEN
            GO TO 130
          ELSE
            IF (err.eq.999) THEN
              i = i+1
              GO TO 130
            ELSE
              GO TO 140
            ENDIF
          ENDIF
c
c...SINIT Resets SEQUENCE Counters
c
        ELSEIF (lb(1:5).eq.'SINIT') THEN
          direction = 1
          nstep = 1
c
c...Otherwise Just Do The Instruction
c
        ELSE
          CALL cc_parse(err)
        ENDIF
        IF (err.eq.0) THEN
          GO TO 130
        ELSE
          GO TO 140
        ENDIF
      ENDIF
c
c...Normal Exit
c
  140 CONTINUE
      RETURN
c
c...Error Exits
c
  200 CONTINUE
      DO i=1,deep
        CALL cc_fclose(err)
      ENDDO
      err = -11
      RETURN
      END
