      SUBROUTINE  nodup(n)
c
c...Remove Duplicate Entry In Sorted Lists
c
c	List Is Already Sorted On IXST.  Choose Brightest Entry.
c
      INCLUDE
     *            '../global.inc'
      PARAMETER
     *            itag = -90909,
     *            rad = 100,
     *            tworad = 2*rad
      INTEGER
     *            low, high, test, xh, keep, mkeep, n, m
      REAL
     *            dx, dy, radsqr
c
c...Initialization
c
  100 low = 0
      high = 0
      radsqr = RAD*RAD
c
c...Outer Loop On LOW Index
c
  110 low = low+1
      IF (low.ge.nstar) GO TO 130
      IF (ixst(low).eq.ITAG) GO TO 110
      xh = ixst(low) + TWORAD
c
c...Inner Loop Test To Adjust HIGH Index
c
      high = MAX(low,high)
      m = high
      DO test=m+1,nstar
        IF (ixst(test).ne.ITAG) THEN
          IF (ixst(test).le.xh) THEN
            high = test
          ELSE
            GO TO 120
          ENDIF
        ENDIF
      ENDDO
c
c...Check Distance Inside The Range LOW,HIGH
c
  120 IF (high.le.low) GO TO 110
      keep = low
      mkeep = MOD(idst(keep),10000)
      DO test=low+1,high
        IF (ixst(test).ne.ITAG) THEN
          dx = ixst(test)-ixst(low)
          dy = iyst(test)-iyst(low)
          IF ((dx*dx+dy*dy).le.RADSQR) THEN
            m = MOD(imst(test),10000)
            IF (m.lt.mkeep) THEN
              ixst(keep) = ITAG
              keep = test
              mkeep = m
            ELSE
              ixst(test) = ITAG
            ENDIF
          ENDIF
        ENDIF
      ENDDO
      GO TO 110
c
c...Fill SINDEX So That We Can Close Up In Parallel
c
  130 n = 0
      DO test=1,nstar
        IF (ixst(test).eq.ITAG) THEN
          sindex(test) = 0
        ELSE
          n = n+1
          sindex(test) = n
          ixst(n) = ixst(test)
        ENDIF
      ENDDO
      RETURN
      END
