      SUBROUTINE  medfilt_2(chunk,nwide)
c
c...Parallel Median Filter TINY To Make SKY
c
      INCLUDE
     *            '../all2.inc'
      INTEGER
     *            ix, iy, ntotal, nr1, nr2, nc1, nc2, ntest,
     *            nwide, iz, chunk, nmost
      INTEGER
     *            save(0:255), hist(0:255)
c
c...Initialize And Loop Over Rows
c
  100 nc1 = nwide + 1
      nc2 = mcols - nwide
      ntotal = mrows - 2*nwide
      nmost = (ntotal-1)/4 + 1
      IF (chunk.eq.1) THEN
        nr1 = nwide + 1
        nr2 = nwide + nmost
      ELSEIF (chunk.eq.2) THEN
        nr1 = nwide + nmost + 1
        nr2 = nwide + 2*nmost
      ELSEIF (chunk.eq.3) THEN
        nr1 = nwide + 2*nmost + 1
        nr2 = nwide + 3*nmost
      ELSE
        nr1 = nwide + 3*nmost + 1
        nr2 = mrows - nwide
      ENDIF
      ntotal = 2*nwide + 1
      ntest = (ntotal*ntotal + 1)/2
c
c...Outer Loop Is Over Y -- Recall Saved Starting Histogram When Possible
c
      DO iy=nr1,nr2
        ix = nc1
        IF (iy.eq.nr1) THEN
          CALL medlong_2(ix,iy,nwide,ntest,skyp(ix,iy),hist)
        ELSE
          DO iz=0,255
            hist(iz) = save(iz)
          ENDDO
          CALL medrow_2(ix,iy,nwide,ntest,skyp(ix,iy),hist)
        ENDIF
        DO iz=0,255
          save(iz) = hist(iz)
        ENDDO
c
c...Inner Loop Removes/Adds A Column From Histogram
c
        DO ix=nc1+1,nc2
          CALL medcolumn_2(ix,iy,nwide,ntest,skyp(ix,iy),hist)
        ENDDO
      ENDDO
c
c...All Chunks Must Fill Column Fringes
c
      DO iy=nr1,nr2
        DO ix=1,nwide
          skyp(ix,iy) = skyp(nc1,iy)
        ENDDO
        DO ix=nc2+1,mcols
          skyp(ix,iy) = skyp(nc2,iy)
        ENDDO
      ENDDO
c
c...First Chunk Must Fill First Row Fringe
c
      IF (chunk.eq.1) THEN
        DO ix=1,mcols
          DO iy=1,nwide
            skyp(ix,iy) = skyp(ix,nr1)
          ENDDO
        ENDDO
      ENDIF
c
c...Last Chunk Must Fill Last Row Fringe
c
      IF (chunk.eq.4) THEN
        DO ix=1,mcols
          DO iy=nr2+1,mrows
            skyp(ix,iy) = skyp(ix,nr2)
          ENDDO
        ENDDO
      ENDIF
      RETURN
      END
