      SUBROUTINE  fitsheader
c
c...Finish The FITS Header
c
c	N Defined By Number Of Lines From FITSPRELIM
c
      INCLUDE
     *            '../global.inc'
      PARAMETER
     *            n = 8
      INTEGER
     *            i, j, k, l, put
      CHARACTER*1
     *            q
c
 9001 FORMAT ('OBJECT  = ', a,a,a)
 9002 FORMAT ('PMMFRAME= ', i20)
 9003 FORMAT ('PMMX    = ', f20.4)
 9004 FORMAT ('PMMY    = ', f20.4)
 9005 FORMAT ('PMMZ    = ', f20.4)
 9006 FORMAT ('PMMA    = ', f20.4)
 9007 FORMAT ('PMMLASER= ', f20.4)
 9008 FORMAT ('PMMTEMP = ', f20.1)
 9009 FORMAT ('PMMNDENS= ', f20.2)
 9010 FORMAT ('PMMTIME = ', f20.6)
 9011 FORMAT ('PMMEXPOS= ', i20)
 9012 FORMAT ('PMMBITS = ', i20)
 9013 FORMAT ('PMMMAGNI= ', i20)
 9014 FORMAT ('PMMSIGMA= ', f20.3)
 9015 FORMAT ('PMMWHLWP= ', f20.3)
 9016 FORMAT ('PMMWHLWW= ', f20.3)
 9017 FORMAT ('PMMFRDN1= ', i20)
 9018 FORMAT ('PMMFRDN2= ', i20)
 9019 FORMAT ('PMMAVSKY= ', f20.3)
 9020 FORMAT ('PMMDZX21= ', 1pe20.8)
 9021 FORMAT ('PMMDZY21= ', 1pe20.8)
 9022 FORMAT ('PMMDZX22= ', 1pe20.8)
 9023 FORMAT ('PMMDZY23= ', 1pe20.8)
 9024 FORMAT ('PMMXCO', i2.2, '= ', 1pe20.8)
 9025 FORMAT ('PMMYCO', i2.2, '= ', 1pe20.8)
 9026 FORMAT ('PMMMAGOF= ', f20.3)
 9027 FORMAT ('PMMMAGSL= ', f20.3)
 9028 FORMAT ('PMMSURVY= ', a,a,a)
 9029 FORMAT ('PMMPLEP = ', f20.1)
 9030 FORMAT ('PMMPLRA = ', a,a,a)
 9031 FORMAT ('PMMPLDEC= ', a,a,a)
 9032 FORMAT ('PMMPLMID= ', a,a,a)
 9033 FORMAT ('PMMPLEXP= ', f20.1)
 9034 FORMAT ('PMMNOW  = ', a,a,a)
 9035 FORMAT ('PMMTAPE = ', a,a,a)
 9036 FORMAT ('PMMSMULT= ', f20.3)
 9037 FORMAT ('PMMEFLAG= ', i20)
 9038 FORMAT ('PMMZCUR = ', f20.3)
 9039 FORMAT ('PMMLLCX = ', f20.3)
 9040 FORMAT ('PMMLLCY = ', f20.3)
 9041 FORMAT ('PMMHOLD = ', i20)
 9042 FORMAT ('PMMPOSIT= ', i20)
 9043 FORMAT ('PMMZREF = ', f20.3)
 9044 FORMAT ('PMMZDOT = ', f20.3)
c
c...Quick Return If Nothing To Do
c
  100 IF ((fitsdoit.eq.0).or.(nframe.le.0)) RETURN
c
c...Fill The Header
c
      q = ''''
      WRITE (grabchead(N+ 1),9001) q,plateid(1:nplateid),q
      WRITE (grabchead(N+ 2),9002) nframe
      WRITE (grabchead(N+ 3),9003) frx0(nframe)
      WRITE (grabchead(N+ 4),9004) fry0(nframe)
      WRITE (grabchead(N+ 5),9005) frz0(nframe)
      WRITE (grabchead(N+ 6),9006) fra0(nframe)
      WRITE (grabchead(N+ 7),9007) frl0(nframe)
      WRITE (grabchead(N+ 8),9008) frc0(nframe)
      WRITE (grabchead(N+ 9),9009) frd0(nframe)
      WRITE (grabchead(N+10),9010) frt0(nframe)
      WRITE (grabchead(N+11),9011) frexp(nframe)
      WRITE (grabchead(N+12),9012) ialternate
      WRITE (grabchead(N+13),9013) parmagnify
      WRITE (grabchead(N+14),9014) parsigma
      WRITE (grabchead(N+15),9015) wholewp
      WRITE (grabchead(N+16),9016) wholeww
      WRITE (grabchead(N+17),9017) frdn1(nframe)
      WRITE (grabchead(N+18),9018) frdn2(nframe)
      WRITE (grabchead(N+19),9019) nomsky
      WRITE (grabchead(N+20),9020) dzxcoef(2,1)
      WRITE (grabchead(N+21),9021) dzycoef(2,1)
      WRITE (grabchead(N+22),9022) dzxcoef(2,2)
      WRITE (grabchead(N+23),9023) dzycoef(2,3)
      WRITE (grabchead(N+24),9026) magoffset
      WRITE (grabchead(N+25),9027) magslope
      WRITE (grabchead(N+26),9028) q,plsurvey,q
      WRITE (grabchead(N+27),9029) plepoch
      WRITE (grabchead(N+28),9030) q,plra,q
      WRITE (grabchead(N+29),9031) q,pldec,q
      WRITE (grabchead(N+30),9032) q,pltime,q
      WRITE (grabchead(N+31),9033) plexpose
      WRITE (grabchead(N+32),9034) q,plnow,q
      WRITE (grabchead(N+33),9035) q,pltape,q
      WRITE (grabchead(N+34),9036) sig_mult
      WRITE (grabchead(N+35),9037) frflag(nframe)
      WRITE (grabchead(N+36),9038) zetacur
      WRITE (grabchead(N+37),9039) llcx
      WRITE (grabchead(N+38),9040) llcy
      WRITE (grabchead(N+39),9041) holder
      WRITE (grabchead(N+40),9042) barpos
      WRITE (grabchead(N+41),9043) zetaref
      WRITE (grabchead(N+42),9044) zetadot
      put = N+40
      DO i=1,ncoef
        put = put+1
        WRITE (grabchead(put),9024) i,xcoef(i)
      ENDDO
      DO i=1,ncoef
        put = put+1
        WRITE (grabchead(put),9025) i,ycoef(i)
      ENDDO
c
c...WARNING.  No END statement here.  END is at true end of FITS block,
c		and was inserted in FITSINIT.
c
c
c...Copy Into FITS Block
c
      l = 1
      k = 0
      DO i=1,36*NGRABHD
        DO j=1,80
          k = k+1
          IF (k.gt.2880) THEN
            l = l+1
            k = k-2880
          ENDIF
          grabhdr(k,l) = ICHAR(grabchead(i)(j:j))
        ENDDO
      ENDDO
      RETURN
      END
