      SUBROUTINE  multiproc(istar)
c
c...PROC In MultiProcessor Environment
c
      INCLUDE
     *            '../global.inc'
      INTEGER
     *             cpu, istar, numap(12), kill, iover
c
c...Image Examination
c
  100 CALL proccenscan(istar,numap,kill)
      IF (kill.ne.0) GO TO 110
c
c...Better Processing Can Selectively Ignore Initial Magnitude Guess
c
      IF (IAND(ialternate,CONSTANT_MAG).ne.0) THEN
        mstar(istar) = 100.0
      ENDIF
c
c...Default Processing
c
      IF (IAND(ialternate,STD_ASTROMETRY).ne.0) THEN
        CALL marg(istar,numap,kill)
        IF (kill.ne.0) GO TO 110
      ENDIF
c
c...Moment-Type Processing
c
      IF (IAND(ialternate,NO_MOMENT).eq.0) THEN
        CALL procapsky(istar,numap)
        CALL procdoap(istar,numap,kill)
        IF (kill.ne.0) GO TO 110
        CALL procunitap(istar,numap)
        CALL procphot(istar,numap)
      ENDIF
c
c...Second Iteration On May Be Beneficial In Forgetting Initial Guess Errors
c
      IF (IAND(ialternate,SECOND_ITER).ne.0) THEN
        CALL procdoap(istar,numap,kill)
        IF (kill.ne.0) GO TO 110
        CALL procunitap(istar,numap)
        CALL procphot(istar,numap)
      ENDIF
c
c...Saturated Pixel Count
c
      IF (IAND(ialternate,COUNT_SAT).ne.0) THEN
        CALL procgetsat(istar,numap)
      ENDIF
c
c...Improved Astrometry
c
      IF (IAND(ialternate,X_ASTROMETRY).ne.0) THEN
        CALL xcent(istar,numap,kill)
        IF (kill.ne.0) GO TO 110
      ENDIF
c
c...Improved Photometry
c
      IF (IAND(ialternate,X_PHOTOMETRY).ne.0) THEN
        CALL xphot(istar,numap,kill)
        IF (kill.ne.0) GO TO 110
      ENDIF
c
c...This Accepts A Star
c
      sindex(istar) = cpu
      RETURN
c
c...This Kills A Star
c
  110 xstar(istar) = tag
      RETURN
      END
