      SUBROUTINE  cc_anoproc
c
c...Monitor Process Of Ano-III And PMM
c
      INCLUDE
     *            'c.inc'
      INTEGER
     *            ready, axis, i, DEV_RTSPMM, iter
      REAL
     *            dt
      CHARACTER*12
     *            now
c
 9001 FORMAT (' Illegal ANO_SEQ = ', i10, 1x, a)
c
c...Quick Returns If Something Is Wrong
c
  100 IF (ano_open.eq.0) RETURN
      IF (ano_seq.eq.0) RETURN
c
c...ANO_SEQ==1 Looks At Video Display
c
      IF (ano_seq.eq.1) THEN
        CALL cc_anostat(ready)
        IF (ready.ne.0) THEN
          ano_seq = 0
          RETURN
        ENDIF
        DO axis=1,4
          IF ((status(axis).ne.'R').and.(status(axis).ne.'M')) GO TO 200
        ENDDO
        CALL cc_getdt(ano_time,dt)
        IF (dt.ge.ano_dt) THEN
          panic = IOR(panic,PANIC_ANO_LATE)
          ano_seq = 0
        ENDIF
c
c...Monitor Via Axis Hang And Write Request
c
      ELSEIF (ano_seq.eq.2) THEN
        nrcv = DEV_RTSPMM(rcv,NIOMAX)
        IF (nrcv.gt.0) THEN
          DO i=1,nrcv
            IF (rcv(i).eq.'/') THEN
              ano_seq = 0
            ENDIF
          ENDDO
        ENDIF
c
c...Unknown Status
c
      ELSE
        CALL cc_gettime(now)
        WRITE (*,9001) ano_seq,now
        ano_seq = 0
      ENDIF
      RETURN
c
c...Serious Error Conditions.
c
c	NOTE:  This doesn't happen very often, but garbage on frame
c		grabs does.  Hence, check error status a few times
c		before panic.
c
  200 DO iter=1,5
      write (*,9991) iter
 9991 format (/ ' ANOPROC Iter=', i1 /)
        CALL cc_anostat(ready)
        IF (ready.ne.0) THEN
          ano_seq = 0
          RETURN
        ENDIF
        DO axis=1,4
          IF ((status(axis).ne.'R').and.(status(axis).ne.'M')) GO TO 210
        ENDDO
        CALL cc_getdt(ano_time,dt)
        IF (dt.ge.ano_dt) THEN
          panic = IOR(panic,PANIC_ANO_LATE)
          ano_seq = 0
        ENDIF
        RETURN
  210   CONTINUE
      ENDDO
c
c...No success means real trouble
c
      IF (status(1).eq.'E')  panic=IOR(panic,PANIC_ANO_XE)
      IF (status(1).eq.'L')  panic=IOR(panic,PANIC_ANO_XL)
      IF (status(1).eq.'I')  panic=IOR(panic,PANIC_ANO_XI)
      IF (status(2).eq.'E')  panic=IOR(panic,PANIC_ANO_YE)
      IF (status(2).eq.'L')  panic=IOR(panic,PANIC_ANO_YL)
      IF (status(2).eq.'I')  panic=IOR(panic,PANIC_ANO_YI)
      IF (status(3).eq.'E')  panic=IOR(panic,PANIC_ANO_ZE)
      IF (status(3).eq.'L')  panic=IOR(panic,PANIC_ANO_ZL)
      IF (status(4).eq.'E')  panic=IOR(panic,PANIC_ANO_AE)
      IF (status(4).eq.'L')  panic=IOR(panic,PANIC_ANO_AL)
      ano_seq = 0
      RETURN
      END
