      SUBROUTINE  cc_anotalk(err)
c
c...Send A Message To Anorad.
c
c	NOTE:  Since almost all Anorad commands are for motion or
c		configuration changes, a SLEEP has been added so
c		as not to confuse the ANO-III with too many commands
c		too quickly.
c
c	NOTE:  Try To Decode Simple Requests And Test For Sanity!
c
      INCLUDE
     *            'c.inc'
      INTEGER
     *            err, DEV_ANOWRITE, nbb, i, frst, last
      BYTE
     *            bb(NIOMAX)
      CHARACTER*1
     *            c
      DOUBLE PRECISION
     *            z
c
 9001 FORMAT (/ ' ANOWRITE Error' /)
 9002 FORMAT (f20.0)
 9003 FORMAT (/ ' Illegal Character' /)
 9004 FORMAT (/ ' Axis Out Of Range' /)
 9005 FORMAT (/ ' MOVE/WAIT Error' /)
c
  100 IF (ano_open.eq.0) RETURN
c
c...Convert To Upper Case And Sense Illegal Characters
c
      DO i=3,nlb
        c = lb(i:i)
        IF ((c.ge.'a').and.(c.le.'z')) THEN
          lb(i:i) = CHAR(ICHAR(c)-32)
        ELSEIF ((c.ge.'A').and.(c.le.'Z')) THEN
          CONTINUE
        ELSEIF ((c.ge.'0').and.(c.le.'9')) THEN
          CONTINUE
        ELSEIF (c.eq.'.') THEN
          CONTINUE
        ELSE
          GO TO 200
        ENDIF
      ENDDO
c
c...Look For Command And Option Fields
c
      last = 2
  110 frst = last+1
      DO last=frst,nlb-1
        c = lb(last+1:last+1)
        IF ((c.lt.'A').or.(c.gt.'Z')) GO TO 120
      ENDDO
      last = nlb
c
c...Parse 1-Character Commands
c
  120 IF (frst.ne.last) THEN
        GO TO 140
      ELSE
        DO i=frst,nlb-1
          c = lb(i+1:i+1)
          IF (((c.ge.'0').and.(c.le.'9')).or.(c.eq.'.')) THEN
            CONTINUE
          ELSE
            GO TO 130
          ENDIF
        ENDDO
        i = nlb
  130   READ (lb(frst+1:i),9002,err=200) z
        c = lb(frst:frst)
        IF (c.eq.'X') THEN
          IF ((z.lt.0.0D00).or.(z.gt.950.0D00)) GO TO 210
          reqpos(1) = z
        ELSEIF (c.eq.'Y') THEN
          IF ((z.lt.0.0D00).or.(z.gt.750.0D00)) GO TO 210
          reqpos(2) = z
        ELSEIF (c.eq.'Z') THEN
          IF ((z.lt.80.0D00).or.(z.gt.99.0D00)) GO TO 210
          reqpos(3) = z
        ELSEIF (c.eq.'A') THEN
          IF ((z.lt.0.0D00).or.(z.gt.1.5D00)) GO TO 210
          reqpos(4) = z
        ELSE
          GO TO 140
        ENDIF
        last = i
        IF (last.lt.nlb) GO TO 110
      ENDIF
c
c...If We Get Here, Then It Was Just A Simple Motion Command
c
      DO i=1,4
        offset(i) = 0.0D00
      ENDDO
      CALL cc_move(err)
      IF (err.ne.0) GO TO 220
      GO TO 150
c
c...If We Get Here, Then It Is Some Sort Of Special Command
c
  140 CALL cc_fromchar(lb(3:nlb),nxmt,xmt)
      err = DEV_ANOWRITE(nxmt,xmt)
      IF (err.ne.0) GO TO 230
c
c...In Either Case, Use WAIT
c
  150 lb(1:4) = 'WAIT'
      nlb = 4
      CALL cc_wait(err)
      IF (err.ne.0) GO TO 220
      RETURN
c
c...Various Error Exits
c
  200 WRITE (*,9003)
      err = -1
      RETURN
  210 WRITE (*,9004)
      err = -2
      RETURN
  220 WRITE (*,9005)
      RETURN
  230 WRITE (*,9001)
      RETURN
      END
