      SUBROUTINE  cc_ispeed(err)
c
c...Interpolate Mode And Set Speed
c
      INCLUDE
     *            'c.inc'
      PARAMETER
     *            max_speed = 3600,
     *            def_speed = 3000,
     *            max_xaccel = 6574,
     *            def_xaccel = 2000,
     *            max_yaccel = 3235,
     *            def_yaccel = 1000
      INTEGER
     *            err, DEV_ANOWRITE, speed, xaccel, yaccel, i, n
      CHARACTER*1
     *            c
c
 9001 FORMAT (3i10)
 9002 FORMAT ('F', i4)
 9003 FORMAT ('G7X', i4, 'G7Y', i4)
c
c...Strip Out =.  Any Other Is Delimiter
c
  100 n = 0
      DO i=7,nlb
        c = lb(i:i)
        IF (c.ne.'=') THEN
          IF ((c.ge.'0').and.(c.le.'9')) THEN
            n = n+1
            lb(n:n) = c
          ELSE
            n = n+1
            lb(n:n) = ','
          ENDIF
        ENDIF
      ENDDO
      nlb = n
c
c...Set Defaults And Parse
c
      speed = 0
      xaccel = 0
      yaccel = 0
      IF (nlb.gt.0) THEN
        READ (lb(1:nlb),9001,err=110) speed,xaccel,yaccel
  110   CONTINUE
      ENDIF
      IF (speed.le.0) THEN
        speed = DEF_SPEED
      ELSE
        speed = MIN(speed,MAX_SPEED)
      ENDIF
      IF (xaccel.le.0) THEN
        xaccel = DEF_XACCEL
      ELSE
        xaccel = MIN(xaccel,MAX_XACCEL)
      ENDIF
      IF (yaccel.le.0) THEN
        yaccel = DEF_YACCEL
      ELSE
        yaccel = MIN(yaccel,MAX_YACCEL)
      ENDIF
c
c...Send Speed Command And Wait For ANO-III TO Shift Modes
c
      WRITE (lb,9002) speed
      nlb = 5
      n = 0
      DO i=1,nlb
        IF (lb(i:i).ne.' ') THEN
          n = n+1
          lb(n:n) = lb(i:i)
        ENDIF
      ENDDO
      nlb = n
      CALL cc_fromchar(lb(1:nlb),nxmt,xmt)
      err = DEV_ANOWRITE(nxmt,xmt)
      IF (err.ne.0) GO TO 200
      CALL cc_sleep(1.0)
c
c...Send Acceleration Command And Wait For ANO-III To Process It
c
      WRITE (lb,9003) xaccel,yaccel
      nlb = 14
      n = 0
      DO i=1,nlb
        IF (lb(i:i).ne.' ') THEN
          n = n+1
          lb(n:n) = lb(i:i)
        ENDIF
      ENDDO
      nlb = n
      CALL cc_fromchar(lb(1:nlb),nxmt,xmt)
      err = DEV_ANOWRITE(nxmt,xmt)
      IF (err.ne.0) GO TO 200
      CALL cc_sleep(0.5)
c
c...All Done
c
      err = 0
      RETURN
  200 err = -20
      panic = IOR(panic,PANIC_ANO_QIO)
      RETURN
      END
