      SUBROUTINE  cc_meanz(err)
c
c...Take Mean Of Several Offsets Around Current Position
c
c	Does UPDATE Type Of Function
c
      INCLUDE
     *            'c.inc'
      PARAMETER
     *            nsample = 5
      INTEGER
     *            err, i, j, n, iz, m, d, y, hh, mm, ss
      CHARACTER*8
     *            tb
      CHARACTER*1
     *            who
      DOUBLE PRECISION
     *            csave(4), vsave(NSAMPLE), xoff(NSAMPLE),
     *            yoff(NSAMPLE), xx, yy, zz, t
      DATA
     *            xoff/ 0.0D00, -5.0D00, -5.0D00,  5.0D00,  5.0D00/,
     *            yoff/ 0.0D00, -4.0D00,  4.0D00,  4.0D00, -4.0D00/
c
 9001 FORMAT (a, '=PMM', f8.4, ',',f8.4, 3(',',f6.3), ',',f13.6,
     *        ',',f4.1, ',',f4.1)
 9002 FORMAT (i2, 1x, i2, 1x, i2)
c
c...Initialization
c
  100 who = lb(6:6)
      IF ((who.ne.'0').and.(who.ne.'1')) THEN
        err = -1
        RETURN
      ENDIF
c
c...Loop Over Various Offsets From Current Position.
c
      DO i=1,NSAMPLE
        IF (who.eq.'0') THEN
          xx = xoff(i) + laseroff(1,1) + separation(1)
          yy = yoff(i) + laseroff(2,1) + separation(2)
        ELSE
          xx = xoff(i) + laseroff(1,2)
          yy = yoff(i) + laseroff(2,2)
        ENDIF
        offset(1) = xx
        offset(2) = yy
        CALL cc_move(err)
        IF (err.ne.0) GO TO 200
        nlb = 4
        lb(1:nlb) = 'WAIT'
        CALL cc_wait(err)
        IF (err.ne.0) GO TO 200
        CALL cc_zsense
        IF (who.eq.'0') THEN
          IF (i.eq.1) THEN
            csave(1) = curpos(1) - laseroff(1,1)
            csave(2) = curpos(2) - laseroff(2,1)
            csave(3) = curpos(3)
            csave(4) = curpos(4)
          ENDIF
          vsave(i) = curpos(5)
        ELSE
          IF (i.eq.1) THEN
            csave(1) = curpos(1) - laseroff(1,2)
            csave(2) = curpos(2) - laseroff(2,2)
            csave(3) = curpos(3)
            csave(4) = curpos(4)
          ENDIF
          vsave(i) = curpos(6)
        ENDIF
      ENDDO
c
c...Use Median
c
      n = NSAMPLE/2 + 1
      DO i=1,n
        zz = vsave(i)
        iz = i
        DO j=i+1,NSAMPLE
          IF (vsave(j).lt.zz) THEN
            iz = j
            zz = vsave(iz)
          ENDIF
        ENDDO
        zz = vsave(i)
        vsave(i) = vsave(iz)
        vsave(iz) = zz
      ENDDO
      IF (who.eq.'0') THEN
        curpos(5) = vsave(n)
      ELSE
        curpos(6) = vsave(n)
      ENDIF
c
c...Tell Appropriate SG
c
      CALL idate(m,d,y)
      CALL time(tb)
      READ (tb,9002) hh,mm,ss
      t = 10000.0D00*y + 100.0D00*m + d + (hh/24.0D00)
     *  + (mm/1440.0D00) + (ss/86400.0D00)
      IF (who.eq.'0') THEN
        WRITE (lb,9001,err=200) who,(csave(i),i=1,4),curpos(5),t,
     *                          tempval(2),den_0val
        nlb = 62
        CALL cc_sg0talk(err)
      ELSE
        WRITE (lb,9001,err=200) who,(csave(i),i=1,4),curpos(6),t,
     *                          tempval(2),den_1val
        nlb = 62
        CALL cc_sg1talk(err)
      ENDIF
      RETURN
c
c...Fatal Error
c
  200 err = -1
      RETURN
      END
