      SUBROUTINE  cc_plate(err)
c
c...Define Many Things For A Plate Pair
c
      INCLUDE
     *            'c.inc'
      INTEGER
     *            err, which, mm, dd, yy, i
      CHARACTER*15
     *            tb
      CHARACTER*5
     *            tp13, tp24
      DOUBLE PRECISION
     *            zx, zy
c
 9001 FORMAT (i2.2, ':')
 9002 FORMAT (i5.5)
 9003 FORMAT ('0=ID', f7.3, ',', f7.3, ',', a)
 9004 FORMAT ('1=ID', f7.3, ',', f7.3, ',', a)
c
c...Sanity Check
c
  100 IF (INDEX(lb(1:nlb),'12').gt.0) THEN
        which = 1
      ELSEIF (INDEX(lb(1:nlb),'34').gt.0) THEN
        which = 2
      ELSE
        err = -1
        RETURN
      ENDIF
      IF ((holder.lt.1).or.(holder.gt.2)) THEN
        err = -2
        RETURN
      ENDIF
c
c...Define PMM Areas And Nominals
c
      IF (which.eq.1) THEN
        lb(1:7) = 'MINMAX1'
        nlb = 7
        CALL cc_minmax(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDZ1'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDA1'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
      ELSE
        lb(1:7) = 'MINMAX2'
        nlb = 7
        CALL cc_minmax(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDZ2'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
        lb(1:7) = 'COORDA2'
        nlb = 7
        CALL cc_coord(err)
        IF (err.ne.0) RETURN
      ENDIF
c
c...Get Current Time And Tape Information
c
      CALL IDATE(mm,dd,yy)
      WRITE (tb(1:3),9001) yy
      CALL cc_gettime(tb(4:15))
      WRITE (tp13,9002) tapeid(1)
      WRITE (tp24,9002) tapeid(2)
c
c...Update SG Plate Name
c
      IF (which.eq.1) THEN
        zx = minval(1)+separation(1)
        zy = minval(2)+separation(2)
        WRITE (lb,9003) zx,zy,plateid(1)(1:nplateid(1))
        nlb = 20+nplateid(1)
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(1)) + LEN(plemul(1)) + LEN(pltim(1))
     *      + LEN(plra(1)) + LEN(pldec(1)) + LEN(plexp(1))
     *      + LEN(tb) + LEN(tp13)
        lb(1:nlb) = '0=INFO'//plsurvey(1)//plemul(1)//pltim(1)
     *                      //plra(1)//pldec(1)//plexp(1)//tb//tp13
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
      ELSE
        zx = minval(1)+separation(1)
        zy = minval(2)+separation(2)
        WRITE (lb,9003) zx,zy,plateid(3)(1:nplateid(3))
        nlb = 20+nplateid(1)
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(3)) + LEN(plemul(3)) + LEN(pltim(3))
     *      + LEN(plra(3)) + LEN(pldec(3)) + LEN(plexp(3))
     *      + LEN(tb) + LEN(tp13)
        lb(1:nlb) = '0=INFO'//plsurvey(3)//plemul(3)//pltim(3)
     *                      //plra(3)//pldec(3)//plexp(3)//tb//tp13
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg0talk(err)
        IF (err.ne.0) RETURN
      ENDIF
      IF (which.eq.1) THEN
        WRITE (lb,9004) minval(1),minval(2),plateid(2)(1:nplateid(2))
        nlb = 20+nplateid(1)
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(2)) + LEN(plemul(2)) + LEN(pltim(2))
     *      + LEN(plra(2)) + LEN(pldec(2)) + LEN(plexp(2))
     *      + LEN(tb) + LEN(tp24)
        lb(1:nlb) = '1=INFO'//plsurvey(2)//plemul(2)//pltim(2)
     *                      //plra(2)//pldec(2)//plexp(2)//tb//tp24
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
      ELSE
        WRITE (lb,9004) minval(1),minval(2),plateid(4)(1:nplateid(4))
        nlb = 20+nplateid(1)
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
        nlb = 6 + LEN(plsurvey(4)) + LEN(plemul(4)) + LEN(pltim(4))
     *      + LEN(plra(4)) + LEN(pldec(4)) + LEN(plexp(4))
     *      + LEN(tb) + LEN(tp24)
        lb(1:nlb) = '1=INFO'//plsurvey(4)//plemul(4)//pltim(4)
     *                      //plra(4)//pldec(4)//plexp(4)//tb//tp24
        DO i=1,nlb
          IF (lb(i:i).eq.':') THEN
            lb(i:i) = ';'
          ENDIF
        ENDDO
        CALL cc_sg1talk(err)
        IF (err.ne.0) RETURN
      ENDIF
      RETURN
      END
